/* header file for autores_listtable.c */

typedef struct {
  int nLists;
  int *startLinkIndexs;    /* [nLists] */
  int startLinkIndexOfFreePool;
  int maxLinks;
  int nLinks;
  int *nextLinkIndexs;  /* [maxLinks] */
  int *linkItemIds;     /* [maxLinks] */
} AutoRes_ListTable;



/* ListTable */

void AutoRes_ListTable_initialize
(AutoRes_ListTable *self,
 int nLists, 
 int nAverageLinksPerList);

void AutoRes_ListTable_terminate
(AutoRes_ListTable *self);

int AutoRes_ListTable_nLists 
(AutoRes_ListTable *self);

#ifdef NDEBUG

#define AutoRes_ListTable_startLinkIndexIn(self,listIndex) \
 (self)->startLinkIndexs[(listIndex)] 

#define AutoRes_ListTable_nextLinkIndex(self,linkIndex) \
  (self)->nextLinkIndexs[(linkIndex)]

#define AutoRes_ListTable_itemId(self,linkIndex) \
  (self)->linkItemIds[(linkIndex)]

#else

int AutoRes_ListTable_startLinkIndexIn 
(AutoRes_ListTable *self,
 int listIndex);

int AutoRes_ListTable_nextLinkIndex 
(AutoRes_ListTable *self,
 int linkIndex);

int AutoRes_ListTable_itemId 
(AutoRes_ListTable *self,
 int linkIndex);

#endif /* NDEBUG */

void AutoRes_ListTable_addItemIn 
(AutoRes_ListTable *self,
 int listIndex, int itemId);

void AutoRes_ListTable_removeItemIn 
(AutoRes_ListTable *self,
 int listIndex, int itemId);
