/* header file for autores_utility2d.c */


/* Nodal Coordinate */

void AutoRes_SetNodalCoordinate2D 
(int nNodes,
 double nodalCoordinates[]     /* [nNodes][2] */   );



/* Node Search */
/* nodal coordinate data must be specified before using this */

void AutoRes_CreateEmptyNodeBucket2D
(double nodalDistance,
 double minRangeX, double minRangeY,
 double maxRangeX, double maxRangeY);

void AutoRes_CreateNodeBucketAndAddNodes2D 
(double nodalDistance);

void AutoRes_AddLastNode2D (void);

AutoRes_Bucket2D *AutoRes_NodeBucket2D (void);

int AutoRes_FindNodeAt2D 
(double x, double y);

void AutoRes_DeleteNodeBucket2D (void);



/* Element-Node Connectivity */

/* 
      N2
       |\
    e1 | \ e0
       |  \
       +---+  
    N0   e2  N1
*/

void AutoRes_SetTriangleMesh2D 
(int nElements,
 int nNodesPerElement,
 int elementNodeIds[]   /* [nElements][nNodesPerElement] */   );

void AutoRes_GetEdgeNodesOfTriangleMesh2D 
(int elementId, int elementEdgeId,
 int *edgeNode0_OUT, int *edgeNode1_OUT);



/* Edge Extraction */
/* element connecvitity data must be specified before using this */

void AutoRes_ExtractEdgesOfTriangleMesh2D 
(int maxEdges,
 int *nEdges_OUT,
 int elementIds_OUT[],
 int elementEdgeIds_OUT[]);



/* Element Search */
/* nodal coordinate and element connecvitity data must be 
   specified before using this */

void AutoRes_CreateTriangleElementBucket2D (void);

AutoRes_Bucket2D *AutoRes_TriangleElementBucket2D (void);

int AutoRes_FindTriangleElementAt2D 
(double x, double y,
 double *L0_OUT, double *L1_OUT, double *L2_OUT);

void AutoRes_DeleteTriangleElementBucket2D (void);
