/* header file for autores_utility3d.c */


/* Nodal Coordinate */

void AutoRes_SetNodalCoordinate3D 
(int nNodes,
 double nodalCoordinates[]     /* [nNodes][3] */   );



/* Node Search */
/* nodal coordinate data must be specified before using this */

void AutoRes_CreateEmptyNodeBucket3D
(double nodalDistance,
 double minRangeX, double minRangeY, double minRangeZ,
 double maxRangeX, double maxRangeY, double maxRangeZ);

void AutoRes_CreateNodeBucketAndAddNodes3D 
(double nodalDistance);

void AutoRes_AddLastNode3D (void);

AutoRes_Bucket3D *AutoRes_NodeBucket3D (void);

int AutoRes_FindNodeAt3D 
(double x, double y, double z);

void AutoRes_DeleteNodeBucket3D (void);



/* Element-Node Connectivity */

/* 
      N3
       |\`
     f1| \f0`+ N2
       |f2\ / 
       +---+ N1  
    N0   f3  
*/

void AutoRes_SetTetrahedronMesh3D 
(int nElements,
 int nNodesPerElement,
 int elementNodeIds[]   /* [nElements][nNodesPerElement] */   );

void AutoRes_GetFaceNodesOfTetrahedronMesh3D 
(int elementId, int elementFaceId,
 int *faceNode0_OUT, int *faceNode1_OUT, int *faceNode2_OUT);



/* Face Extraction */
/* element connecvitity data must be specified before using this */

void AutoRes_ExtractFacesOfTetrahedronMesh3D 
(int maxFaces,
 int *nFaces_OUT,
 int elementIds_OUT[],
 int elementFaceIds_OUT[]);



/* Element Search */
/* nodal coordinate and element connecvitity data must be 
   specified before using this */

void AutoRes_CreateTetrahedronElementBucket3D (void);

AutoRes_Bucket3D *AutoRes_TetrahedronElementBucket3D (void);

int AutoRes_FindTetrahedronElementAt3D 
(double x, double y, double z,
 double *L0_OUT, double *L1_OUT, double *L2_OUT, double *L3_OUT);

void AutoRes_DeleteTetrahedronElementBucket3D (void);
