/* listtable_id_sample.c */

/* sample of list table */
/* use it as a hash table of integer ID */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "autores.h"



int HashTableSize = 5;
AutoRes_ListTable IdTable;

int HashFunction (int itemId)
{
  return itemId % HashTableSize;
}

int main (int argc, char* argv[])
{
  int nAverageLinksPerList;
  int itemId;
  int iList;
  int linkIndex;
  int itemIdToBeFound;

  nAverageLinksPerList = 10;
  AutoRes_ListTable_initialize 
    (&IdTable,
     HashTableSize, 
     nAverageLinksPerList);



  printf (" <add> \n");

  itemId = 101;
  AutoRes_ListTable_addItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);
  itemId = 102;
  AutoRes_ListTable_addItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);
  itemId = 103;
  AutoRes_ListTable_addItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);
  itemId = 106;
  AutoRes_ListTable_addItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);
  itemId = 107;
  AutoRes_ListTable_addItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);

  for (iList = 0; 
       iList < AutoRes_ListTable_nLists 
	 (&IdTable); 
       iList++) {
    printf (" list ID %d \t", iList);

    for (linkIndex = AutoRes_ListTable_startLinkIndexIn 
	   (&IdTable, 
	    iList);
	 linkIndex != -1;
	 linkIndex = AutoRes_ListTable_nextLinkIndex 
	   (&IdTable, 
	    linkIndex)) {
      int itemId = AutoRes_ListTable_itemId 
	(&IdTable, 
	 linkIndex);
      
      printf (" %d ", itemId);
    }

    printf ("\n");
  }
  
  itemIdToBeFound = 102;
  printf (" search %d \n", itemIdToBeFound);
  for (linkIndex = AutoRes_ListTable_startLinkIndexIn 
	 (&IdTable, 
	  HashFunction (itemIdToBeFound));
       linkIndex != -1;
       linkIndex = AutoRes_ListTable_nextLinkIndex 
	 (&IdTable, 
	  linkIndex)) {
    int itemId = AutoRes_ListTable_itemId 
      (&IdTable, 
       linkIndex);
    
    printf (" check %d \n", itemId);
    if (itemId == itemIdToBeFound) {
      printf (" %d IS FOUND \n", itemIdToBeFound);
    }
  }

  itemIdToBeFound = 110;
  printf (" search %d \n", itemIdToBeFound);
  for (linkIndex = AutoRes_ListTable_startLinkIndexIn 
	 (&IdTable, 
	  HashFunction (itemIdToBeFound));
       linkIndex != -1;
       linkIndex = AutoRes_ListTable_nextLinkIndex 
	 (&IdTable, 
	  linkIndex)) {
    int itemId = AutoRes_ListTable_itemId 
      (&IdTable, 
       linkIndex);
    
    printf (" check %d \n", itemId);
    if (itemId == itemIdToBeFound) {
      printf (" %d IS FOUND \n", itemIdToBeFound);
    }
  }



  printf (" <remove> \n");

  itemId = 101;
  AutoRes_ListTable_removeItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);
  itemId = 102;
  AutoRes_ListTable_removeItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);
  itemId = 107;
  AutoRes_ListTable_removeItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);

  for (iList = 0; 
       iList < AutoRes_ListTable_nLists 
	 (&IdTable); 
       iList++) {
    printf (" list ID %d \t", iList);

    for (linkIndex = AutoRes_ListTable_startLinkIndexIn 
	   (&IdTable, 
	    iList);
	 linkIndex != -1;
	 linkIndex = AutoRes_ListTable_nextLinkIndex 
	   (&IdTable, 
	    linkIndex)) {
      int itemId = AutoRes_ListTable_itemId 
	(&IdTable, 
	 linkIndex);
      
      printf (" %d ", itemId);
    }

    printf ("\n");
  }

  itemIdToBeFound = 101;
  printf (" search %d \n", itemIdToBeFound);
  for (linkIndex = AutoRes_ListTable_startLinkIndexIn 
	 (&IdTable, 
	  HashFunction (itemIdToBeFound));
       linkIndex != -1;
       linkIndex = AutoRes_ListTable_nextLinkIndex 
	 (&IdTable, 
	  linkIndex)) {
    int itemId = AutoRes_ListTable_itemId 
      (&IdTable, 
       linkIndex);
    
    printf (" check %d \n", itemId);
    if (itemId == itemIdToBeFound) {
      printf (" %d IS FOUND \n", itemIdToBeFound);
    }
  }

  itemIdToBeFound = 103;
  printf (" search %d \n", itemIdToBeFound);
  for (linkIndex = AutoRes_ListTable_startLinkIndexIn 
	 (&IdTable, 
	  HashFunction (itemIdToBeFound));
       linkIndex != -1;
       linkIndex = AutoRes_ListTable_nextLinkIndex 
	 (&IdTable, 
	  linkIndex)) {
    int itemId = AutoRes_ListTable_itemId 
      (&IdTable, 
       linkIndex);
    
    printf (" check %d \n", itemId);
    if (itemId == itemIdToBeFound) {
      printf (" %d IS FOUND \n", itemIdToBeFound);
    }
  }



  printf (" <add> \n");

  itemId = 107;
  AutoRes_ListTable_addItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);
  itemId = 108;
  AutoRes_ListTable_addItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);
  itemId = 109;
  AutoRes_ListTable_addItemIn 
    (&IdTable,
     HashFunction (itemId), itemId);

  for (iList = 0; 
       iList < AutoRes_ListTable_nLists 
	 (&IdTable); 
       iList++) {
    printf (" list ID %d \t", iList);

    for (linkIndex = AutoRes_ListTable_startLinkIndexIn 
	   (&IdTable, 
	    iList);
	 linkIndex != -1;
	 linkIndex = AutoRes_ListTable_nextLinkIndex 
	   (&IdTable, 
	    linkIndex)) {
      int itemId = AutoRes_ListTable_itemId 
	(&IdTable, 
	 linkIndex);
      
      printf (" %d ", itemId);
    }

    printf ("\n");
  }
  


  AutoRes_ListTable_terminate 
    (&IdTable);

  return 0;
}
