/* listtable_word_sample.c */

/* sample of list table */
/* use it as a hash table of character string word */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "autores.h"



int HashTableSize = 10;
AutoRes_ListTable WordTable;

#define MAX_WORDS 10
char *Words[MAX_WORDS] = {
  "Hello",
  "World",
  "This",
  "is",
  "a",
  "pen",
  "Thank",
  "you",
  "very",
  "much",
};



int HashFunction (char *str)
{
  int sum;
  int i;

  sum = 0;
  for (i = 0; i < strlen (str); i++) {
    sum += str[i];
  }
  return sum % HashTableSize;
}

int main (int argc, char* argv[])
{
  int nAverageLinksPerList;
  int iWord;
  int iList;
  int linkIndex;
  char *wordToBeFound;

  nAverageLinksPerList = 10;
  AutoRes_ListTable_initialize 
    (&WordTable,
     HashTableSize, 
     nAverageLinksPerList);



  for (iWord = 0; iWord < MAX_WORDS; iWord++) {
    AutoRes_ListTable_addItemIn 
      (&WordTable,
       HashFunction (Words[iWord]), iWord);
  }

  for (iList = 0; 
       iList < AutoRes_ListTable_nLists 
	 (&WordTable); 
       iList++) {
    printf (" list ID %d \t", iList);

    for (linkIndex = AutoRes_ListTable_startLinkIndexIn 
	   (&WordTable, 
	    iList);
	 linkIndex != -1;
	 linkIndex = AutoRes_ListTable_nextLinkIndex 
	   (&WordTable, 
	    linkIndex)) {
      int itemId = AutoRes_ListTable_itemId 
	(&WordTable, 
	 linkIndex);
      
      printf (" %d=%s ", itemId, Words[itemId]);
    }

    printf ("\n");
  }
  
  wordToBeFound = "you";
  printf (" search %s \n", wordToBeFound);
  for (linkIndex = AutoRes_ListTable_startLinkIndexIn 
	 (&WordTable, 
	  HashFunction (wordToBeFound));
       linkIndex != -1;
       linkIndex = AutoRes_ListTable_nextLinkIndex 
	 (&WordTable, 
	  linkIndex)) {
    int itemId = AutoRes_ListTable_itemId 
      (&WordTable, 
       linkIndex);
    
    printf (" check %d=%s \n", itemId, Words[itemId]);
    if (strcmp (Words[itemId], wordToBeFound) == 0) {
      printf (" FIND %s at %d \n", wordToBeFound, itemId);
    }
  }
  


  AutoRes_ListTable_terminate 
    (&WordTable);

  return 0;
}
