/* header file for autores_array.c */

#ifndef __AUTORES_ARRAY__
#define __AUTORES_ARRAY__



/* Array */



/* Array 2D */

typedef struct _AutoRes_Array2D {
  AutoRes_Handle handle;

  AutoRes_Table *table;
  int size0;
  int size1;
} AutoRes_Array2D;

AUTORES_DECLARE_HANDLE(AutoRes_Array2D);

AutoRes_Array2D *AutoRes_Array2D_New 
(AutoRes_Table *table,
 int size0, 
 int size1);

void AutoRes_Array2D_delete 
(AutoRes_Array2D *self);

AutoRes_Table *AutoRes_Array2D_table 
(AutoRes_Array2D *self);

int AutoRes_Array2D_size0 
(AutoRes_Array2D *self);

int AutoRes_Array2D_size1 
(AutoRes_Array2D *self);

int AutoRes_Array2D_recordId 
(AutoRes_Array2D *self,
 int index0,
 int index1);



/* Array  3D */

typedef struct _AutoRes_Array3D {
  AutoRes_Handle handle;

  AutoRes_Table *table;
  int size0;
  int size1;
  int size2;
} AutoRes_Array3D;

AUTORES_DECLARE_HANDLE(AutoRes_Array3D);

AutoRes_Array3D *AutoRes_Array3D_New 
(AutoRes_Table *table,
 int size0, 
 int size1, 
 int size2);

void AutoRes_Array3D_delete 
(AutoRes_Array3D *self);

AutoRes_Table *AutoRes_Array3D_table 
(AutoRes_Array3D *self);

int AutoRes_Array3D_size0 
(AutoRes_Array3D *self);

int AutoRes_Array3D_size1 
(AutoRes_Array3D *self);

int AutoRes_Array3D_size2 
(AutoRes_Array3D *self);

int AutoRes_Array3D_recordId 
(AutoRes_Array3D *self,
 int index0,
 int index1,
 int index2);



#endif  /* __AUTORES_ARRAY__ */



