/* header file for autores_bucket1d.c */

#ifndef __AUTORES_BUCKET1D__
#define __AUTORES_BUCKET1D__



/* Bucket1D */

typedef struct _AutoRes_Bucket1D {
  AutoRes_Handle handle;

  double minRangeX;
  double maxRangeX;
  int xCells;

  AutoRes_ListTable *listTable;  /* OWN */
} AutoRes_Bucket1D;

AUTORES_DECLARE_HANDLE(AutoRes_Bucket1D);

AutoRes_Bucket1D *AutoRes_Bucket1D_New 
(double minRangeX, 
 double maxRangeX);

void AutoRes_Bucket1D_delete 
(AutoRes_Bucket1D *self);

int /* boolean */
AutoRes_Bucket1D_reserve 
(AutoRes_Bucket1D *self,
 int xCells, 
 int nAverageLinksPerList);

void AutoRes_Bucket1D_getMinRange 
(AutoRes_Bucket1D *self,
 double *minRangeX_OUT);

void AutoRes_Bucket1D_getMaxRange 
(AutoRes_Bucket1D *self,
 double *maxRangeX_OUT);

void AutoRes_Bucket1D_getNCells 
(AutoRes_Bucket1D *self,
 int *xCells_OUT);

void AutoRes_Bucket1D_getCellIdWithin 
(AutoRes_Bucket1D *self,
 double minRangeX,
 double maxRangeX,
 int *cx0_OUT, 
 int *cx1_OUT);

void AutoRes_Bucket1D_getCellIdAt 
(AutoRes_Bucket1D *self,
 double x,
 int *cx_OUT);

int /* boolean */   
AutoRes_Bucket1D_isOutOfRange 
(AutoRes_Bucket1D *self,
 int cx);

int AutoRes_Bucket1D_startLinkIdIn 
(AutoRes_Bucket1D *self,
 int cx);

int AutoRes_Bucket1D_startLinkIdOutOfRange 
(AutoRes_Bucket1D *self);

int AutoRes_Bucket1D_nextLinkId 
(AutoRes_Bucket1D *self,
 int linkId);

int AutoRes_Bucket1D_objectId 
(AutoRes_Bucket1D *self,
 int linkId);

int /* boolean */ 
AutoRes_Bucket1D_addObjectWithin 
(AutoRes_Bucket1D *self,
 double minRangeX,
 double maxRangeX,
 int objectId);

int /* boolean */  
AutoRes_Bucket1D_addObjectAt 
(AutoRes_Bucket1D *self,
 double x,
 int objectId);

void AutoRes_Bucket1D_removeObjectWithin 
(AutoRes_Bucket1D *self,
 double minRangeX,
 double maxRangeX,
 int objectId);

void AutoRes_Bucket1D_removeObjectAt 
(AutoRes_Bucket1D *self,
 double x,
 int objectId);



#endif  /* __AUTORES_BUCKET1D__ */



