/* autores_collection.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "autores_base.h"
#include "autores_memory.h"
#include "autores_column.h"
#include "autores_integer_column.h"
#include "autores_real_column.h"
#include "autores_collection.h"



/* Collection */

void AutoRes_Collection_MakeNewIdColumn 
(AutoRes_IntegerColumn *useFlagColumn,
 AutoRes_IntegerColumn *newIdColumn)
{
  AutoRes_Table *table;
  int nRecords;
  int count;
  int iRecord;

  assert(AutoRes_IntegerColumn_table (useFlagColumn)
	 == AutoRes_IntegerColumn_table (newIdColumn));

  table = AutoRes_IntegerColumn_table (useFlagColumn);
  nRecords = AutoRes_Table_nRecords (table);
  count = 0;
  for (iRecord = 0; iRecord < nRecords; iRecord++) {
    int useFlag = AUTORES_I(useFlagColumn, iRecord);

    if (useFlag) {
      AUTORES_I_SET(newIdColumn, iRecord, count);
      count++;
    } else {
      AUTORES_I_SET(newIdColumn, iRecord, -1);
    }
  }
}

void AutoRes_Collection_RenumberIdColumn 
(AutoRes_IntegerColumn *newIdColumn, 
 AutoRes_IntegerColumn *idColumn)
{
  AutoRes_Table *table;
  int nRecords;
  int iRecord;

  table = AutoRes_IntegerColumn_table (idColumn);
  nRecords = AutoRes_Table_nRecords (table);

  for (iRecord = 0; iRecord < nRecords; iRecord++) {
    int id = AUTORES_I(idColumn, iRecord);
    int newId = AUTORES_I(newIdColumn, id);
    
    assert(0 <= newId);
    AUTORES_I_SET(idColumn, iRecord, newId);
  }
}



