/* autores_field.c : Field */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "autores_base.h"
#include "autores_field.h"
#include "autores_integer_field.h"
#include "autores_real_field.h"



/* Field */



/* Field */

void AutoRes_Field_Initialize (void)
{
  AutoRes_IntegerField_Initialize ();
  AutoRes_Integer1DField_Initialize ();
  AutoRes_RealField_Initialize ();
  AutoRes_Real1DField_Initialize ();
}

int /* boolean */
AutoRes_Field_HandleIsValid 
(AutoRes_Handle handle, 
 AutoRes_FieldType fieldType)
{
  switch (fieldType) {
  case AUTORES_FIELD_INTEGER:
    return AutoRes_IntegerField_HandleIsValid (handle);
    break;
  case AUTORES_FIELD_INTEGER1D:
    return AutoRes_Integer1DField_HandleIsValid (handle);
    break;
  case AUTORES_FIELD_REAL:
    return AutoRes_RealField_HandleIsValid (handle);
    break;
  case AUTORES_FIELD_REAL1D:
    return AutoRes_Real1DField_HandleIsValid (handle);
    break;
  default:
    assert(0);
    break;
  }
  return 0;
}

void AutoRes_Field_delete 
(void *self, 
 AutoRes_FieldType fieldType)
{
  switch (fieldType) {
  case AUTORES_FIELD_INTEGER:
    AutoRes_IntegerField_delete 
      ((AutoRes_IntegerField *)self);
    break;
  case AUTORES_FIELD_INTEGER1D:
    AutoRes_Integer1DField_delete 
      ((AutoRes_Integer1DField *)self);
    break;
  case AUTORES_FIELD_REAL:
    AutoRes_RealField_delete 
      ((AutoRes_RealField *)self);
    break;
  case AUTORES_FIELD_REAL1D:
    AutoRes_Real1DField_delete 
      ((AutoRes_Real1DField *)self);
    break;
  default:
    assert(0);
    break;
  }
}

void AutoRes_Field_getName 
(void *self, 
 AutoRes_FieldType fieldType,
 char *name_OUT)
{
  switch (fieldType) {
  case AUTORES_FIELD_INTEGER:
    AutoRes_IntegerField_getName 
      ((AutoRes_IntegerField *)self, 
       name_OUT);
    break;
  case AUTORES_FIELD_INTEGER1D:
    AutoRes_Integer1DField_getName 
      ((AutoRes_Integer1DField *)self, 
       name_OUT);
    break;
  case AUTORES_FIELD_REAL:
    AutoRes_RealField_getName 
      ((AutoRes_RealField *)self, 
       name_OUT);
    break;
  case AUTORES_FIELD_REAL1D:
    AutoRes_Real1DField_getName 
      ((AutoRes_Real1DField *)self, 
       name_OUT);
    break;
  default:
    assert(0);
    break;
  }
}

