/* header file for autores_file.c */

#ifndef __AUTORES_FILE__
#define __AUTORES_FILE__

/* File I/O */



/* File */

typedef struct _AutoRes_File {
  AutoRes_Handle handle;

  int writeFlag;
  int binaryFlag;
  FILE *fp;
} AutoRes_File;

AUTORES_DECLARE_HANDLE(AutoRes_File);
  
AutoRes_File *AutoRes_File_New (void);

void AutoRes_File_delete 
(AutoRes_File *self);

int /* boolean */
AutoRes_File_open
(AutoRes_File *self,
 const char *fileName,
 int writeFlag,
 int binaryFlag);

int /* boolean */
AutoRes_File_close 
(AutoRes_File *self);

int /* boolean */
AutoRes_File_integer 
(AutoRes_File *self,
 int *value_IO);

int /* boolean */
AutoRes_File_real 
(AutoRes_File *self,
 double *value_IO);

int /* boolean */
AutoRes_File_string 
(AutoRes_File *self,
 int length,
 char *value_IO);

int /* boolean */
AutoRes_File_nextLine 
(AutoRes_File *self);

int /* boolean */
AutoRes_File_writeFlag
(AutoRes_File *self);

int /* boolean */
AutoRes_File_binaryFlag
(AutoRes_File *self);



#if 0

void AutoRes_File_fillSpaceOnString
(AutoRes_File *self);

void AutoRes_File_setDelimiter
(AutoRes_File *self,
 int ch);

void AutoRes_File_setDefaultIntegerColumnWidth
(AutoRes_File *self,
 int width);

void AutoRes_File_setDefaultRealColumnWidth
(AutoRes_File *self,
 int width);

void AutoRes_File_setDefaultStringColumnWidth
(AutoRes_File *self,
 int width);

void AutoRes_File_setColumnWidth
(AutoRes_File *self,
 int width);

#endif



#endif  /* __AUTORES_FILE__ */
