/* header file for autores_free_list.c */

#ifndef __AUTORES_FREE_LIST__
#define __AUTORES_FREE_LIST__



/* Free List Collection */

typedef struct _AutoRes_FreeListCollection {
  AutoRes_Handle handle;

  AutoRes_Table *table;
  AutoRes_IntegerColumn *nextRecordIdColumn;
  int startRecordId;
} AutoRes_FreeListCollection;

AUTORES_DECLARE_HANDLE(AutoRes_FreeListCollection);

AutoRes_FreeListCollection *AutoRes_FreeListCollection_New 
(AutoRes_Table *table);

void AutoRes_FreeListCollection_delete 
(AutoRes_FreeListCollection *self);

int /* boolean */
AutoRes_FreeListCollection_makeColumn 
(AutoRes_FreeListCollection *self);

void AutoRes_FreeListCollection_initializeColumn 
(AutoRes_FreeListCollection *self);

int AutoRes_FreeListCollection_addRecord 
(AutoRes_FreeListCollection *self);

void AutoRes_FreeListCollection_removeRecord 
(AutoRes_FreeListCollection *self,
 int recordId);

void AutoRes_FreeListCollection_pack 
(AutoRes_FreeListCollection *self);

AutoRes_Table *AutoRes_FreeListCollection_table 
(AutoRes_FreeListCollection *self);

int /* boolean */
AutoRes_FreeListCollection_recordIsUsed 
(AutoRes_FreeListCollection *self,
 int recordId);



#endif  /* __AUTORES_FREE_LIST__ */



