/* header file for autores_integer_field.c */

#ifndef __AUTORES_INTEGER_FIELD__
#define __AUTORES_INTEGER_FIELD__

/* Integer Field */



/* IntegerField */

typedef struct _AutoRes_IntegerField {
  AutoRes_Handle handle;

  char *name;  /* OWN */
  int value;
  int *valuePtr;
} AutoRes_IntegerField;

AUTORES_DECLARE_HANDLE(AutoRes_IntegerField);

AutoRes_IntegerField *AutoRes_IntegerField_New 
(const char *name);

void AutoRes_IntegerField_delete 
(AutoRes_IntegerField *self);

void AutoRes_IntegerField_associate 
(AutoRes_IntegerField *self,
 int *valuePtr);

void AutoRes_IntegerField_setValue 
(AutoRes_IntegerField *self,
 int value);

void AutoRes_IntegerField_getName 
(AutoRes_IntegerField *self,
 char *name_OUT);

int AutoRes_IntegerField_value 
(AutoRes_IntegerField *self);



/* Integer1DField */

typedef struct _AutoRes_Integer1DField {
  AutoRes_Handle handle;

  char *name;  /* OWN */
  int size;
  int *values;  /* values[size], OWN */
  int *valuesPtr;  
} AutoRes_Integer1DField;

AUTORES_DECLARE_HANDLE(AutoRes_Integer1DField);

AutoRes_Integer1DField *AutoRes_Integer1DField_New 
(const char *name,
 int size);

void AutoRes_Integer1DField_delete 
(AutoRes_Integer1DField *self);

void AutoRes_Integer1DField_associate 
(AutoRes_Integer1DField *self,
 int *valuesPtr);

void AutoRes_Integer1DField_setValue 
(AutoRes_Integer1DField *self,
 int index,
 int value);

void AutoRes_Integer1DField_getName 
(AutoRes_Integer1DField *self,
 char *name_OUT);

int AutoRes_Integer1DField_size 
(AutoRes_Integer1DField *self);

int AutoRes_Integer1DField_value 
(AutoRes_Integer1DField *self,
 int index);



#endif  /* __AUTORES_INTEGER_FIELD__ */



