/* header file for autores_list.c */

#ifndef __AUTORES_LIST__
#define __AUTORES_LIST__



/* List */

typedef struct _AutoRes_List {
  AutoRes_Handle handle;

  int startLinkId;
  int endLinkId;
  int freeLinkId;
  AutoRes_Table *links;   /* OWN */
  AutoRes_IntegerColumn *links_nextLinkId;
  AutoRes_IntegerColumn *links_prevLinkId;
  AutoRes_IntegerColumn *links_objectId;
} AutoRes_List;

AUTORES_DECLARE_HANDLE(AutoRes_List);

AutoRes_List *AutoRes_List_New (void);

void AutoRes_List_delete 
(AutoRes_List *self);

int /* boolean */
AutoRes_List_allocate 
(AutoRes_List *self,
 int nInitialLinks);

int /* boolean */
AutoRes_List_addLinkAtFirst 
(AutoRes_List *self,
 int objectId);

int /* boolean */
AutoRes_List_addLinkAtLast 
(AutoRes_List *self,
 int objectId);

void AutoRes_List_removeLink 
(AutoRes_List *self,
 int linkId);

int AutoRes_List_startLinkId
(AutoRes_List *self);

int AutoRes_List_nextLinkId 
(AutoRes_List *self,
 int linkId);

int AutoRes_List_endLinkId
(AutoRes_List *self);

int AutoRes_List_prevLinkId 
(AutoRes_List *self,
 int linkId);

int AutoRes_List_objectId 
(AutoRes_List *self,
 int linkId);



#endif  /* __AUTORES_LIST__ */



