/* header file for autores_list_table.c */

#ifndef __AUTORES_LIST_TABLE__
#define __AUTORES_LIST_TABLE__



/* List Table */

typedef struct _AutoRes_ListTable {
  AutoRes_Handle handle;

  int nLists;

  AutoRes_Table *lists;  /* OWN, [nLists] */
  AutoRes_IntegerColumn *lists_startLinkId;

  AutoRes_Table *links;   /* OWN */
  AutoRes_IntegerColumn *links_nextLinkId;
  AutoRes_IntegerColumn *links_objectId;
  int freeLinkId;
} AutoRes_ListTable;

AUTORES_DECLARE_HANDLE(AutoRes_ListTable);

AutoRes_ListTable *AutoRes_ListTable_New (void);

void AutoRes_ListTable_delete 
(AutoRes_ListTable *self);

int /* boolean */
AutoRes_ListTable_reserve 
(AutoRes_ListTable *self,
 int nLists,
 int nAverageLinksPerList);

int AutoRes_ListTable_addObject 
(AutoRes_ListTable *self,
 int listId, 
 int objectId);

void AutoRes_ListTable_removeObject 
(AutoRes_ListTable *self,
 int listId, 
 int objectId);

int AutoRes_ListTable_nLists 
(AutoRes_ListTable *self);

int AutoRes_ListTable_startLinkId
(AutoRes_ListTable *self,
 int listId);

int AutoRes_ListTable_nextLinkId 
(AutoRes_ListTable *self,
 int linkId);

int AutoRes_ListTable_objectId 
(AutoRes_ListTable *self,
 int linkId);



#endif  /* __AUTORES_LIST_TABLE__ */



