/* header file for autores_memory.c */

#ifndef __AUTORES_MEMORY__
#define __AUTORES_MEMORY__

/* Memory Management System */



/* Memory */

typedef struct _AutoRes_Block {
  char *dataArea;
  int blockId;
  int useFlag;
  int memorySize;
  int lockFlag;
} AutoRes_Block;

int /* boolean */
AutoRes_Memory_Initialize 
(int memorySize);

AutoRes_Block *AutoRes_Memory_AllocateBlock 
(int memorySize);

void AutoRes_Memory_FreeBlock 
(AutoRes_Block *block);

int /* boolean */ 
AutoRes_Memory_ReallocateBlock 
(AutoRes_Block *block,
 int memorySize);

void AutoRes_Memory_SetLockFlagOnBlock 
(AutoRes_Block *block,
 int flag);



#endif  /* __AUTORES_MEMORY__ */



