/* header file for autores_ordered.c */

#ifndef __AUTORES_ORDERED__
#define __AUTORES_ORDERED__



/* Ordered Collection */

typedef struct _AutoRes_OrderedCollection {
  AutoRes_Handle handle;

  AutoRes_Table *table;
  int startRecordId;
  int endRecordId;
  int freeRecordId;
  AutoRes_IntegerColumn *nextRecordIdColumn;
  AutoRes_IntegerColumn *prevRecordIdColumn;
} AutoRes_OrderedCollection;

AUTORES_DECLARE_HANDLE(AutoRes_OrderedCollection);

AutoRes_OrderedCollection *AutoRes_OrderedCollection_New 
(AutoRes_Table *table);

void AutoRes_OrderedCollection_delete 
(AutoRes_OrderedCollection *self);

int /* boolean */
AutoRes_OrderedCollection_makeColumn 
(AutoRes_OrderedCollection *self);

void AutoRes_OrderedCollection_initializeColumn 
(AutoRes_OrderedCollection *self);

int AutoRes_OrderedCollection_addRecord 
(AutoRes_OrderedCollection *self);

void AutoRes_OrderedCollection_removeRecord 
(AutoRes_OrderedCollection *self,
 int recordId);

AutoRes_Table *AutoRes_OrderedCollection_table 
(AutoRes_OrderedCollection *self);

int /* boolean */
AutoRes_OrderedCollection_recordIsUsed 
(AutoRes_OrderedCollection *self,
 int recordId);

int AutoRes_OrderedCollection_startRecordId 
(AutoRes_OrderedCollection *self);

int AutoRes_OrderedCollection_endRecordId 
(AutoRes_OrderedCollection *self);

int AutoRes_OrderedCollection_nextRecordId 
(AutoRes_OrderedCollection *self,
 int recordId);

int AutoRes_OrderedCollection_prevRecordId 
(AutoRes_OrderedCollection *self,
 int recordId);



#endif  /* __AUTORES_ORDERED__ */



