/* header file for autores_real_field.c */

#ifndef __AUTORES_REAL_FIELD__
#define __AUTORES_REAL_FIELD__

/* Real Field */



/* RealField */

typedef struct _AutoRes_RealField {
  AutoRes_Handle handle;

  char *name;  /* OWN */
  double value;
  double *valuePtr;
} AutoRes_RealField;

AUTORES_DECLARE_HANDLE(AutoRes_RealField);

AutoRes_RealField *AutoRes_RealField_New 
(const char *name);

void AutoRes_RealField_delete 
(AutoRes_RealField *self);

void AutoRes_RealField_associate 
(AutoRes_RealField *self,
 double *valuePtr);

void AutoRes_RealField_setValue 
(AutoRes_RealField *self,
 double value);

void AutoRes_RealField_getName 
(AutoRes_RealField *self,
 char *name_OUT);

double AutoRes_RealField_value 
(AutoRes_RealField *self);



/* Real1DField */

typedef struct _AutoRes_Real1DField {
  AutoRes_Handle handle;

  char *name;  /* OWN */
  int size;
  double *values;  /* values[size], OWN */
  double *valuesPtr;  
} AutoRes_Real1DField;

AUTORES_DECLARE_HANDLE(AutoRes_Real1DField);

AutoRes_Real1DField *AutoRes_Real1DField_New 
(const char *name,
 int size);

void AutoRes_Real1DField_delete 
(AutoRes_Real1DField *self);

void AutoRes_Real1DField_associate 
(AutoRes_Real1DField *self,
 double *valuesPtr);

void AutoRes_Real1DField_setValue 
(AutoRes_Real1DField *self,
 int index,
 double value);

void AutoRes_Real1DField_getName 
(AutoRes_Real1DField *self,
 char *name_OUT);

int AutoRes_Real1DField_size 
(AutoRes_Real1DField *self);

double AutoRes_Real1DField_value 
(AutoRes_Real1DField *self,
 int index);



#endif  /* __AUTORES_REAL_FIELD__ */



