/* header file for autores_sorter.c */

#ifndef __AUTORES_SORTER__
#define __AUTORES_SORTER__



/* Integer Sorter */

typedef struct _AutoRes_IntegerSorter {
  AutoRes_Handle handle;

  int nEntrys;

  AutoRes_Table *entrys;  /* OWN */
  AutoRes_IntegerColumn *entrys_objectId;
  AutoRes_IntegerColumn *entrys_value;
} AutoRes_IntegerSorter;

AUTORES_DECLARE_HANDLE(AutoRes_IntegerSorter);

AutoRes_IntegerSorter *AutoRes_IntegerSorter_New 
(int nEntrys);

void AutoRes_IntegerSorter_delete 
(AutoRes_IntegerSorter *self);

int /* boolean */
AutoRes_IntegerSorter_allocate 
(AutoRes_IntegerSorter *self);

void AutoRes_IntegerSorter_setValue 
(AutoRes_IntegerSorter *self,
 int entryId,
 int value);

void AutoRes_IntegerSorter_sort 
(AutoRes_IntegerSorter *self);

int AutoRes_IntegerSorter_nEntrys 
(AutoRes_IntegerSorter *self);

int AutoRes_IntegerSorter_objectId 
(AutoRes_IntegerSorter *self,
 int entryId);

int AutoRes_IntegerSorter_value 
(AutoRes_IntegerSorter *self,
 int entryId);



/* Real Sorter */

typedef struct _AutoRes_RealSorter {
  AutoRes_Handle handle;

  int nEntrys;

  AutoRes_Table *entrys;  /* OWN */
  AutoRes_IntegerColumn *entrys_objectId;
  AutoRes_RealColumn *entrys_value;
} AutoRes_RealSorter;

AUTORES_DECLARE_HANDLE(AutoRes_RealSorter);

AutoRes_RealSorter *AutoRes_RealSorter_New 
(int nEntrys);

void AutoRes_RealSorter_delete 
(AutoRes_RealSorter *self);

int /* boolean */
AutoRes_RealSorter_allocate 
(AutoRes_RealSorter *self);

void AutoRes_RealSorter_setValue 
(AutoRes_RealSorter *self,
 int entryId,
 double value);

void AutoRes_RealSorter_sort 
(AutoRes_RealSorter *self);

int AutoRes_RealSorter_nEntrys 
(AutoRes_RealSorter *self);

int AutoRes_RealSorter_objectId 
(AutoRes_RealSorter *self,
 int entryId);

double AutoRes_RealSorter_value 
(AutoRes_RealSorter *self,
 int entryId);



#endif  /* __AUTORES_SORTER__ */



