/* header file for autores_use_flag.c */

#ifndef __AUTORES_USE_FLAG__
#define __AUTORES_USE_FLAG__



/* Use Flag Collection */

typedef struct _AutoRes_UseFlagCollection {
  AutoRes_Handle handle;

  AutoRes_Table *table;
  AutoRes_IntegerColumn *useFlagColumn;
} AutoRes_UseFlagCollection;

AUTORES_DECLARE_HANDLE(AutoRes_UseFlagCollection);

AutoRes_UseFlagCollection *AutoRes_UseFlagCollection_New 
(AutoRes_Table *table);

void AutoRes_UseFlagCollection_delete 
(AutoRes_UseFlagCollection *self);

int /* boolean */
AutoRes_UseFlagCollection_makeColumn 
(AutoRes_UseFlagCollection *self);

void AutoRes_UseFlagCollection_initializeColumn 
(AutoRes_UseFlagCollection *self);

int AutoRes_UseFlagCollection_addRecord 
(AutoRes_UseFlagCollection *self);

void AutoRes_UseFlagCollection_removeRecord 
(AutoRes_UseFlagCollection *self,
 int recordId);

void AutoRes_UseFlagCollection_pack 
(AutoRes_UseFlagCollection *self);

AutoRes_Table *AutoRes_UseFlagCollection_table 
(AutoRes_UseFlagCollection *self);

int /* boolean */
AutoRes_UseFlagCollection_recordIsUsed 
(AutoRes_UseFlagCollection *self,
 int recordId);



#endif  /* __AUTORES_USE_FLAG__ */



