/* sample_list_table.c */

/* sample of list table */
/* use it as a hash table of integer ID */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "autores.h"



static int HashTableSize = 5;

static int HashFunction (int objectId)
{
  return objectId % HashTableSize;
}

static void TestListTable (void)
{
  AutoRes_ListTable *listTable;
  int nLists = HashTableSize;
  int nAverageLinksPerList = 10;
  int objectId;
  int listId;
  int linkId;
  int objectIdToBeFound;
  int iList;

  printf (" TestListTable \n"); 

  listTable = AutoRes_ListTable_New ();
  
  AutoRes_ListTable_reserve 
    (listTable, nLists, nAverageLinksPerList);



  printf (" add \n");

  objectId = 101;
  AutoRes_ListTable_addObject 
    (listTable, HashFunction (objectId), objectId);
  objectId = 102;
  AutoRes_ListTable_addObject 
    (listTable, HashFunction (objectId), objectId);
  objectId = 103;
  AutoRes_ListTable_addObject 
    (listTable, HashFunction (objectId), objectId);
  objectId = 106;
  AutoRes_ListTable_addObject 
    (listTable, HashFunction (objectId), objectId);
  objectId = 107;
  AutoRes_ListTable_addObject 
    (listTable, HashFunction (objectId), objectId);

  for (iList = 0; iList < nLists; iList++) {
    printf (" list ID %d \t", iList);

    for (linkId = AutoRes_ListTable_startLinkId (listTable, iList);
	 linkId != -1;
	 linkId = AutoRes_ListTable_nextLinkId (listTable, linkId)) {
      int objectId = AutoRes_ListTable_objectId (listTable, linkId);
      
      printf (" %d ", objectId);
    }

    printf ("\n");
  }
  
  objectIdToBeFound = 102;
  printf (" search %d \n", objectIdToBeFound);
  listId = HashFunction (objectIdToBeFound);
  for (linkId = AutoRes_ListTable_startLinkId (listTable, listId);
       linkId != -1;
       linkId = AutoRes_ListTable_nextLinkId (listTable, linkId)) {
    int objectId = AutoRes_ListTable_objectId (listTable, linkId);
    
    printf (" check %d \n", objectId);
    if (objectId == objectIdToBeFound) {
      printf (" %d IS FOUND \n", objectIdToBeFound);
    }
  }

  objectIdToBeFound = 110;
  printf (" search %d \n", objectIdToBeFound);
  listId = HashFunction (objectIdToBeFound);
  for (linkId = AutoRes_ListTable_startLinkId (listTable, listId);
       linkId != -1;
       linkId = AutoRes_ListTable_nextLinkId (listTable, linkId)) {
    int objectId = AutoRes_ListTable_objectId (listTable, linkId);
    
    printf (" check %d \n", objectId);
    if (objectId == objectIdToBeFound) {
      printf (" %d IS FOUND \n", objectIdToBeFound);
    }
  }



  printf (" remove \n");

  objectId = 101;
  AutoRes_ListTable_removeObject 
    (listTable, HashFunction (objectId), objectId);
  objectId = 102;
  AutoRes_ListTable_removeObject 
    (listTable, HashFunction (objectId), objectId);
  objectId = 107;
  AutoRes_ListTable_removeObject 
    (listTable, HashFunction (objectId), objectId);

  for (iList = 0; iList < nLists; iList++) {
    printf (" list ID %d \t", iList);

    for (linkId = AutoRes_ListTable_startLinkId (listTable, iList);
	 linkId != -1;
	 linkId = AutoRes_ListTable_nextLinkId (listTable, linkId)) {
      int objectId = AutoRes_ListTable_objectId (listTable, linkId);
      
      printf (" %d ", objectId);
    }

    printf ("\n");
  }

  objectIdToBeFound = 101;
  printf (" search %d \n", objectIdToBeFound);
  listId = HashFunction (objectIdToBeFound);
  for (linkId = AutoRes_ListTable_startLinkId (listTable, listId);
       linkId != -1;
       linkId = AutoRes_ListTable_nextLinkId (listTable, linkId)) {
    int objectId = AutoRes_ListTable_objectId (listTable, linkId);
    
    printf (" check %d \n", objectId);
    if (objectId == objectIdToBeFound) {
      printf (" %d IS FOUND \n", objectIdToBeFound);
    }
  }

  objectIdToBeFound = 103;
  printf (" search %d \n", objectIdToBeFound);
  listId = HashFunction (objectIdToBeFound);
  for (linkId = AutoRes_ListTable_startLinkId (listTable, listId);
       linkId != -1;
       linkId = AutoRes_ListTable_nextLinkId (listTable, linkId)) {
    int objectId = AutoRes_ListTable_objectId (listTable, linkId);
    
    printf (" check %d \n", objectId);
    if (objectId == objectIdToBeFound) {
      printf (" %d IS FOUND \n", objectIdToBeFound);
    }
  }



  printf (" add \n");

  objectId = 107;
  AutoRes_ListTable_addObject 
    (listTable, HashFunction (objectId), objectId);
  objectId = 108;
  AutoRes_ListTable_addObject 
    (listTable, HashFunction (objectId), objectId);
  objectId = 109;
  AutoRes_ListTable_addObject 
    (listTable, HashFunction (objectId), objectId);

  for (iList = 0; iList < nLists; iList++) {
    printf (" list ID %d \t", iList);
    
    for (linkId = AutoRes_ListTable_startLinkId (listTable, iList);
	 linkId != -1;
	 linkId = AutoRes_ListTable_nextLinkId (listTable, linkId)) {
      int objectId = AutoRes_ListTable_objectId (listTable, linkId);
      
      printf (" %d ", objectId);
    }

    printf ("\n");
  }
  


  AutoRes_ListTable_delete (listTable);
}



int main (int argc, char *argv[])
{
  AutoRes_Initialize (0);

  TestListTable ();

  return 0;
}

